#include <qthing.h>

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"

#include "driver/gpio.h"

#include "mqtt_common.h"
#include "esp_log.h"


#include "FastDimmer.hpp"


// #######################
// ####### CONFIG ########
// #######################

// TODO: may be swapped!
const uint8_t IO_BLUE = 32;
const uint8_t IO_GREEN = 33;

const uint8_t IO_PT4115 = 23;

// ### end cfg ###


void device_main() {

  // enable_wlan();


  FastDimmer pt4115(IO_PT4115);


  uint8_t tickFrequency = 60;

  uint16_t f = 0;

  TickType_t lastWakeTime = xTaskGetTickCount();
  while (true) {

    if (f < 256) {
      pt4115.setBrightness( f / 256.0 );
    } else if (f < 512) {
      pt4115.setBrightness( 1.0f - (f-256) / 256.0 );
    }

    if (f++ >= 512) f = 0;

    vTaskDelayUntil(&lastWakeTime, 1000 / tickFrequency / portTICK_PERIOD_MS);
  }
}
